import { JsonFragment } from '@ethersproject/abi';
interface FunctionData {
    name: string;
    values: ValueMap;
}
interface FunctionOutputData {
    name: string;
    values: ValueMap;
}
interface Constructor {
    values: ValueMap;
}
interface Event {
    name: string;
    values: ValueMap;
}
interface EventEncoding {
    topics: string[];
    data: string;
}
declare type Value = any;
declare type ValueMap = Record<string, Value>;
declare class Coder {
    private abi;
    constructor(abi: JsonFragment[]);
    getFunctionSelector(name: string): string;
    getEventTopic(name: string): string;
    decodeConstructor(data: string): Constructor;
    decodeEvent(topics: string[], data: string): Event;
    decodeFunction(data: string): FunctionData;
    decodeFunctionOutput(name: string, data: string): FunctionOutputData;
    encodeConstructor(valueMap: ValueMap): string;
    encodeEvent(name: string, values: Record<string, Value>): EventEncoding;
    encodeFunction(name: string, valueMap: Record<string, Value>): string;
    encodeFunctionOutput(name: string, valueMap: Record<string, Value>): string;
    private getConstructor;
    private getFunctionByName;
    private getFunctionBySelector;
    private getEventByName;
    private getEventByTopic;
    private static getSignature;
}
export default Coder;
export { FunctionData, FunctionOutputData, Constructor, Event, EventEncoding };
//# sourceMappingURL=index.d.ts.map